+++
title = "Accesos directos"
weight = 1
+++

#### Globales

Iterar en todos los accesos directos. Accesos directos disponibles para todas las aplicaciones.

```python
for acceso_directo, comando in app.shortcuts:
    app.debug(acceso_directo, comando)
```

Devolver una lista de tuplas con toda la información.

```python
datos = app.shortcuts.get_all()
app.debug(datos)
```

Verificar si un acceso directo esta asignado.

```python
acceso_directo = 'Shift+Ctrl+Alt+T'
app.debug(acceso_directo in app.shortcuts)
```

### set

Establecer un acceso directo a un comando.

```python
sc = app.shortcuts
acceso_directo = 'Shift+Ctrl+Alt+T'
comando = 'MacroDialog'
sc.set(acceso_directo, comando)
```

Establecer un acceso directo a una macro.

```python
sc = app.shortcuts
acceso_directo = 'Shift+Ctrl+Alt+M'
macro = {'library': 'test', 'name': 'pruebas'}
sc.set(acceso_directo, macro)
```


### get_by_shortcut

Devolver el comando asociado a un acceso directo.

```python
sc = app.shortcuts
acceso_directo = 'Shift+Ctrl+Alt+M'
comando = sc.get_by_shortcut(acceso_directo)
app.debug(comando)
```


### get_by_command

Devolver el acceso directo asociado a un comando. Puede haber más de uno.

```python
sc = app.shortcuts
comando = 'MacroDialog'
acceso_directo = sc.get_by_command(comando)
app.debug(acceso_directo)
```


### remove_by_shortcut

Eliminar por acceso directo.

```python
sc = app.shortcuts
acceso_directo = 'Shift+Ctrl+Alt+T'
sc.remove_by_shortcut(acceso_directo)
```


### remove_by_command

Eliminar por comando.

```python
sc = app.shortcuts
macro = {'library': 'test', 'name': 'pruebas'}
sc.remove_by_command(macro)
```

### reset

Reiniciar todas las modificaciones.

```python
app.shortcuts.reset()
```


#### Modificar accesos directos, solo en una aplicación.

Por ejemplo Calc.

```python
sc = app.shortcuts['calc']
```

Los métodos son los mismos que los globales.

Para las demas aplicaciones: `writer`, `draw`, `impress`, `math`.
