+++
title = "Conjuntos de Rangos"
weight = 2
+++

#### Trabajar con conjuntos de rangos

### Selección

Obtener una referencia desde la selección actual. Deben de estar seleccionados más de un rango de celdas.

```python
doc = app.active
seleccion = doc.selection
app.debug(seleccion)
```

```
20/08/2022 13:21:17 - DEBUG - Ranges: ('Sheet1.A5:C8', 'Sheet1.E11:F14')
```


### len

Contar los rangos.

```python
doc = app.active
contar = len(doc.selection)
app.debug(contar)
```


### iter

Iterar entre los rangos.

```python
doc = app.active
for rango in doc.selection:
    app.debug(rango)
```

```
20/08/2022 13:27:03 - DEBUG - Range: $Sheet1.$B$4:$D$7
20/08/2022 13:27:03 - DEBUG - Range: $Sheet1.$G$10:$H$14
```


### index

Referencia a un rango por índice.

```python
doc = app.active
rangos = doc.selection

rango = rangos[1]
app.debug(rango)
```

### address

Referencia a un rango por su dirección.

```python
rango = rangos['Hoja1.A1:B5']
app.debug(rango)
```


### contain

Verificar si un rango esta en la colección.

```python
doc = app.active
hoja = doc.active
rangos = doc.selection

resultado = hoja['D5:F10'] in rangos
app.debug(resultado)
```
