+++
title = "Métodos"
weight = 2
+++

### unprotect

Quitar contraseña.

```python
hoja = app.active.active

hoja.password = 'siscaloburropanzon'
app.msgbox(hoja.is_protected)

hoja.unprotect('siscaloburropanzon')
app.msgbox(hoja.is_protected)
```


### activate

Pasar el foco a la hoja.

```python
doc = app.active
hoja = doc[-1]
hoja.activate()
```


### move

Mover a la última posición.

```python
doc = app.active
hoja = doc[0]
hoja.move()
```

Mover a una posición especifica.

```python
doc = app.active
hoja = doc[0]
hoja.move(3)
```

### remove

Remover hoja.

```python
sheet = app.active.active
sheet.remove()
```

{{% notice warning %}}
Siempre debe existir al menos una hoja.
{{% /notice %}}


### copy

{{% notice tip %}}
Siempre valida que no exista el nuevo nombre.
{{% /notice %}}

```python
doc = app.active
hoja = doc[0]

nuevo_nombre = f'{hoja.name}_2'
if not nuevo_nombre in doc:
    hoja.copy(nuevo_nombre)
```

Si no se establece el nuevo nombre, se generá de forma automática: `nombre + índice`.

```python
hoja.copy()
```

### copy_to

Copiar la hoja a otro documento. Se usa el mismo nombre.

```python
doc = app.active
hoja = doc.active

documento_nuevo = app.docs.new()
hoja.copy_to(documento_nuevo)
```

Usar un nuevo nombre.

```python
hoja.copy_to(documento_nuevo, 'Nuevo nombre')
```
