+++
title = "Ejecutar macros"
weight = 6
+++

Ejecutar cualquier macro, de forma predeterminada se llaman a las macros en Python localizadas en el perfil de usuario.

```python
import easymacro as app


def mostrar_info():
    app.msgbox(app.INFO_DEBUG)
    return


def main(args=None):
    macro = {
        'library': 'test',
        'name': 'mostrar_info',
    }
    app.macro.call(macro)
    return
```

Ejecutar una macro compartida en LibreOffice Macros.

```python
macro = {
    'library': 'HelloWorld',
    'name': 'HelloWorldPython',
    'location': 'share',
}
app.macro.call(macro)
```

Ejecutar una macro Basic.

```vb
Sub mostrar_info()
    MsgBox "Mejor usa Python :)"
End Sub
```

```python
macro = {
    'language': 'Basic',
    'library': 'Standard',
    'module': 'Module1',
    'name': 'mostrar_info',
}
app.macro.call(macro)
```

Cualquier macro se puede ejecutar en otro hilo.

```python
app.macro.call(macro, True)
```


Más información en: [Scripting Framework URI Specification][1]


[1]: https://wiki.documentfoundation.org/Documentation/DevGuide/Scripting_Framework#Scripting_Framework_URI_Specification
